require "goose_game/cell"

module GooseGame
  class GameBoard
    WINNING_CELLS = [63]
    BRIDGE_CELLS = [6]
    GOOSE_CELLS = [5, 9, 14, 18, 23, 27]

    def [](n)
      cells.fetch(n) { Cell::Bounce.new(n, self) }
    end

    def cells
      @cells ||= (0..FINISH).reduce({}) { |acc, n| acc[n] = Cell::Base.new(n, self); acc }.tap do |cells|
        WINNING_CELLS.each { |n| cells[n] = Cell::Winning.new(n, self) }
        BRIDGE_CELLS.each { |n| cells[n] = Cell::Bridge.new(n, self) }
        GOOSE_CELLS.each { |n| cells[n] = Cell::Goose.new(n, self) }
      end
    end
  end
end
